Imports Microsoft.EntityFrameworkCore.Migrations
Imports Microsoft.EntityFrameworkCore.Metadata

Namespace SamuraiApp.Data.Migrations
	Partial Public Class initial
		Inherits Migration
		Protected Overrides Sub Up(ByVal migrationBuilder As MigrationBuilder)
            migrationBuilder.CreateTable(name:="Battles", columns:=Function(table) New With {Key .Id = table.Column(Of Integer)(nullable:=False).Annotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn), Key .EndDate = table.Column(Of Date)(nullable:=False), Key .Name = table.Column(Of String)(nullable:=True), Key .StartDate = table.Column(Of Date)(nullable:=False)}, constraints:=Function(table) {table.PrimaryKey("PK_Battles", Function(x) x.Id)})

            migrationBuilder.CreateTable(name:="Samurais", columns:=Function(table) New With {Key .Id = table.Column(Of Integer)(nullable:=False).Annotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn), Key .BattleId = table.Column(Of Integer)(nullable:=False), Key .Name = table.Column(Of String)(nullable:=True)}, constraints:=Function(table) {table.PrimaryKey("PK_Samurais", Function(x) x.Id), table.ForeignKey(name:="FK_Samurais_Battles_BattleId", column:=Function(x) x.BattleId, principalTable:="Battles", principalColumn:="Id", onDelete:=ReferentialAction.Cascade)})

            migrationBuilder.CreateTable(name:="Quotes", columns:=Function(table) New With {Key .Id = table.Column(Of Integer)(nullable:=False).Annotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn), Key .SamuraiId = table.Column(Of Integer)(nullable:=False), Key .Text = table.Column(Of String)(nullable:=True)}, constraints:=Function(table) {table.PrimaryKey("PK_Quotes", Function(x) x.Id), table.ForeignKey(name:="FK_Quotes_Samurais_SamuraiId", column:=Function(x) x.SamuraiId, principalTable:="Samurais", principalColumn:="Id", onDelete:=ReferentialAction.Cascade)})

            migrationBuilder.CreateIndex(name:="IX_Quotes_SamuraiId", table:="Quotes", column:="SamuraiId")

            migrationBuilder.CreateIndex(name:= "IX_Samurais_BattleId", table:= "Samurais", column:= "BattleId")
		End Sub

		Protected Overrides Sub Down(ByVal migrationBuilder As MigrationBuilder)
			migrationBuilder.DropTable(name:= "Quotes")

			migrationBuilder.DropTable(name:= "Samurais")

			migrationBuilder.DropTable(name:= "Battles")
		End Sub
	End Class
End Namespace
