Imports Microsoft.EntityFrameworkCore.Migrations
Imports Microsoft.EntityFrameworkCore.Metadata

Namespace SamuraiApp.Data.Migrations
	Partial Public Class SecretIdentity
		Inherits Migration
		Protected Overrides Sub Up(ByVal migrationBuilder As MigrationBuilder)
            migrationBuilder.CreateTable(name:="SecretIdentity", columns:=Function(table) New With {Key .Id = table.Column(Of Integer)(nullable:=False).Annotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn), Key .RealName = table.Column(Of String)(nullable:=True), Key .SamuraiId = table.Column(Of Integer)(nullable:=False)}, constraints:=Function(table) {table.PrimaryKey("PK_SecretIdentity", Function(x) x.Id), table.ForeignKey(name:="FK_SecretIdentity_Samurais_SamuraiId", column:=Function(x) x.SamuraiId, principalTable:="Samurais", principalColumn:="Id", onDelete:=ReferentialAction.Cascade)})

            migrationBuilder.CreateIndex(name:= "IX_SecretIdentity_SamuraiId", table:= "SecretIdentity", column:= "SamuraiId", unique:= True)
		End Sub

		Protected Overrides Sub Down(ByVal migrationBuilder As MigrationBuilder)
			migrationBuilder.DropTable(name:= "SecretIdentity")
		End Sub
	End Class
End Namespace
