Imports Microsoft.EntityFrameworkCore
Imports Microsoft.EntityFrameworkCore.Infrastructure
Imports Microsoft.EntityFrameworkCore.Metadata
Imports Microsoft.EntityFrameworkCore.Migrations
Imports SamuraiApp.Data

Namespace SamuraiApp.Data.Migrations
	<DbContext(GetType(SamuraiContext)), Migration("20161117234326_AddSprocs")>
	Partial Public Class AddSprocs
		Protected Overrides Sub BuildTargetModel(ByVal modelBuilder As ModelBuilder)
			modelBuilder.HasAnnotation("ProductVersion", "1.1.0-preview1-22509").HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn)

			modelBuilder.Entity("SamuraiApp.Domain.Battle", Sub(b)
				b.Property(Of Integer)("Id").ValueGeneratedOnAdd
				b.Property(Of Date)("EndDate")
				b.Property(Of String)("Name")
				b.Property(Of Date)("StartDate")
				b.HasKey("Id")
				b.ToTable("Battles")
			End Sub)

			modelBuilder.Entity("SamuraiApp.Domain.Quote", Sub(b)
				b.Property(Of Integer)("Id").ValueGeneratedOnAdd
				b.Property(Of Integer)("SamuraiId")
				b.Property(Of String)("Text")
				b.HasKey("Id")
				b.HasIndex("SamuraiId")
				b.ToTable("Quotes")
			End Sub)

			modelBuilder.Entity("SamuraiApp.Domain.Samurai", Sub(b)
				b.Property(Of Integer)("Id").ValueGeneratedOnAdd
				b.Property(Of String)("Name")
				b.HasKey("Id")
				b.ToTable("Samurais")
			End Sub)

			modelBuilder.Entity("SamuraiApp.Domain.SamuraiBattle", Sub(b)
				b.Property(Of Integer)("BattleId")
				b.Property(Of Integer)("SamuraiId")
				b.HasKey("BattleId", "SamuraiId")
				b.HasIndex("SamuraiId")
				b.ToTable("SamuraiBattle")
			End Sub)

			modelBuilder.Entity("SamuraiApp.Domain.SecretIdentity", Sub(b)
				b.Property(Of Integer)("Id").ValueGeneratedOnAdd
				b.Property(Of String)("RealName")
				b.Property(Of Integer)("SamuraiId")
				b.HasKey("Id")
				b.HasIndex("SamuraiId").IsUnique
				b.ToTable("SecretIdentity")
			End Sub)

			modelBuilder.Entity("SamuraiApp.Domain.Quote", Sub(b) b.HasOne("SamuraiApp.Domain.Samurai", "Samurai").WithMany("Quotes").HasForeignKey("SamuraiId").OnDelete(DeleteBehavior.Cascade))

			modelBuilder.Entity("SamuraiApp.Domain.SamuraiBattle", Sub(b)
				b.HasOne("SamuraiApp.Domain.Battle", "Battle").WithMany("SamuraiBattles").HasForeignKey("BattleId").OnDelete(DeleteBehavior.Cascade)
				b.HasOne("SamuraiApp.Domain.Samurai", "Samurai").WithMany("SamuraiBattles").HasForeignKey("SamuraiId").OnDelete(DeleteBehavior.Cascade)
			End Sub)

			modelBuilder.Entity("SamuraiApp.Domain.SecretIdentity", Sub(b) b.HasOne("SamuraiApp.Domain.Samurai", "Samurai").WithOne("SecretIdentity").HasForeignKey("SamuraiApp.Domain.SecretIdentity", "SamuraiId").OnDelete(DeleteBehavior.Cascade))
		End Sub
	End Class
End Namespace
