Imports Microsoft.EntityFrameworkCore.Migrations

Namespace SamuraiApp.Data.Migrations
	Partial Public Class AddSprocs
		Inherits Migration
		Protected Overrides Sub Up(ByVal migrationBuilder As MigrationBuilder)
	  migrationBuilder.DropIndex(name:= "IX_SamuraiBattle_BattleId", table:= "SamuraiBattle")

	  migrationBuilder.Sql("CREATE PROCEDURE FilterSamuraiByNamePart" & ControlChars.CrLf & "              @namepart varchar(50) " & ControlChars.CrLf & "              AS" & ControlChars.CrLf & "              select * from samurais where name like '%'+@namepart+'%'")

		  migrationBuilder.Sql("create procedure FindLongestName" & ControlChars.CrLf & "              @procResult varchar(50) OUTPUT" & ControlChars.CrLf & "              AS" & ControlChars.CrLf & "              BEGIN" & ControlChars.CrLf & "              SET NOCOUNT ON;" & ControlChars.CrLf & "              select top 1 @procResult= name from samurais order by len(name) desc" & ControlChars.CrLf & "              END")
		End Sub

		Protected Overrides Sub Down(ByVal migrationBuilder As MigrationBuilder)
			migrationBuilder.CreateIndex(name:= "IX_SamuraiBattle_BattleId", table:= "SamuraiBattle", column:= "BattleId")
		   migrationBuilder.Sql("DROP PROCEDURE FindLongestName")
		   migrationBuilder.Sql("drop procedure FilterSamuraiByNamePart")
		End Sub
	End Class
End Namespace
