Imports Microsoft.EntityFrameworkCore.Storage
Imports Microsoft.Extensions.Logging

Namespace SamuraiApp.Data
    Public Class MyLoggerProvider
        Implements ILoggerProvider
        Public Function CreateLogger(ByVal categoryName As String) As ILogger
            Return New MyLogger
        End Function

        Private Function ILoggerProvider_CreateLogger(categoryName As String) As ILogger Implements ILoggerProvider.CreateLogger
            Throw New NotImplementedException()
        End Function

        Private Sub IDisposable_Dispose() Implements IDisposable.Dispose
            Throw New NotImplementedException()
        End Sub

        Private Class MyLogger
            Implements ILogger

            Public Function IsEnabled(ByVal logLevel As LogLevel) As Boolean
                Return True
            End Function

            Public Sub Log(Of TState)(ByVal logLevel As LogLevel, ByVal eventId As EventId, ByVal state As TState, ByVal exception As Exception, ByVal formatter As Func(Of TState, Exception, String))
                'Note, the DbCommandLogData class will be replaced at some point so be wary of using it
                If TypeOf state Is DbCommandLogData Then
                    Console.WriteLine(formatter(state, exception))
                    Console.WriteLine()
                End If
            End Sub


            Public Function BeginScope(Of TState)(ByVal state As TState) As IDisposable
                Return Nothing
            End Function

            Private Sub ILogger_Log(Of TState)(logLevel As LogLevel, eventId As EventId, state As TState, exception As Exception, formatter As Func(Of TState, Exception, String)) Implements ILogger.Log
                Throw New NotImplementedException()
            End Sub

            Private Function ILogger_IsEnabled(logLevel As LogLevel) As Boolean Implements ILogger.IsEnabled
                Throw New NotImplementedException()
            End Function

            Private Function ILogger_BeginScope(Of TState)(state As TState) As IDisposable Implements ILogger.BeginScope
                Throw New NotImplementedException()
            End Function
        End Class
    End Class
End Namespace
